A Python parser for MediaWiki wikicode https://mwparserfromhell.readthedocs.io/
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 
 
 

167 lines
4.8 KiB

  1. #! /usr/bin/env bash
  2. set -euo pipefail
  3. if [[ -z "$1" ]]; then
  4. echo "usage: $0 1.2.3"
  5. exit 1
  6. fi
  7. VERSION=$1
  8. SCRIPT_DIR=$(dirname "$0")
  9. RELEASE_DATE=$(date +"%B %-d, %Y")
  10. check_git() {
  11. if [[ -n "$(git status --porcelain --untracked-files=no)" ]]; then
  12. echo "Aborting: dirty working directory."
  13. exit 1
  14. fi
  15. if [[ "$(git rev-parse --abbrev-ref HEAD)" != "develop" ]]; then
  16. echo "Aborting: not on develop."
  17. exit 1
  18. fi
  19. echo -n "Are you absolutely ready to release? [yN] "
  20. read confirm
  21. if [[ ${confirm,,} != "y" ]]; then
  22. exit 1
  23. fi
  24. }
  25. update_version() {
  26. echo -n "Updating mwparserfromhell.__version__..."
  27. sed -e 's/__version__ = .*/__version__ = "'$VERSION'"/' -i "" mwparserfromhell/__init__.py
  28. echo " done."
  29. }
  30. update_appveyor() {
  31. filename="appveyor.yml"
  32. echo -n "Updating $filename..."
  33. sed -e "s/version: .*/version: $VERSION-b{build}/" -i "" $filename
  34. echo " done."
  35. }
  36. update_changelog() {
  37. filename="CHANGELOG"
  38. echo -n "Updating $filename..."
  39. sed -e "1s/.*/v$VERSION (released $RELEASE_DATE):/" -i "" $filename
  40. echo " done."
  41. }
  42. update_docs_changelog() {
  43. filename="docs/changelog.rst"
  44. echo -n "Updating $filename..."
  45. dashes=$(seq 1 $(expr ${#VERSION} + 1) | sed 's/.*/-/' | tr -d '\n')
  46. previous_lineno=$(expr $(grep -n -e "^---" $filename | sed '2q;d' | cut -d ':' -f 1) - 1)
  47. previous_version=$(sed $previous_lineno'q;d' $filename)
  48. sed \
  49. -e "4s/.*/v$VERSION/" \
  50. -e "5s/.*/$dashes/" \
  51. -e "7s/.*/\`Released $RELEASE_DATE <https:\/\/github.com\/earwig\/mwparserfromhell\/tree\/v$VERSION>\`_/" \
  52. -e "8s/.*/(\`changes <https:\/\/github.com\/earwig\/mwparserfromhell\/compare\/$previous_version...v$VERSION>\`__):/" \
  53. -i "" $filename
  54. echo " done."
  55. }
  56. do_git_stuff() {
  57. echo -n "Git: committing, tagging, and merging release..."
  58. git commit -qam "release/$VERSION"
  59. git tag v$VERSION -s -m "version $VERSION"
  60. git checkout -q master
  61. git merge -q --no-ff develop -m "Merge develop into master (release/$VERSION)"
  62. echo -n " pushing..."
  63. git push -q --tags origin master
  64. git checkout -q develop
  65. git push -q origin develop
  66. echo " done."
  67. }
  68. upload_to_pypi() {
  69. echo -n "PyPI: uploading source tarball..."
  70. python setup.py -q register sdist upload -s
  71. echo " done."
  72. }
  73. post_release() {
  74. echo
  75. echo "*** Release completed."
  76. echo "*** Update: https://github.com/earwig/mwparserfromhell/releases/tag/v$VERSION"
  77. echo "*** Verify: https://pypi.python.org/pypi/mwparserfromhell"
  78. echo "*** Verify: https://ci.appveyor.com/project/earwig/mwparserfromhell"
  79. echo "*** Verify: https://mwparserfromhell.readthedocs.io"
  80. echo "*** Press enter to sanity-check the release."
  81. read
  82. }
  83. test_release() {
  84. echo
  85. echo "Checking mwparserfromhell v$VERSION..."
  86. echo -n "Creating a virtualenv..."
  87. virtdir="mwparser-test-env"
  88. virtualenv -q $virtdir
  89. cd $virtdir
  90. source bin/activate
  91. echo " done."
  92. echo -n "Installing mwparserfromhell with pip..."
  93. pip -q install mwparserfromhell
  94. echo " done."
  95. echo -n "Checking version..."
  96. reported_version=$(python -c 'print __import__("mwparserfromhell").__version__')
  97. if [[ "$reported_version" != "$VERSION" ]]; then
  98. echo " error."
  99. echo "*** ERROR: mwparserfromhell is reporting its version as $reported_version, not $VERSION!"
  100. deactivate
  101. cd ..
  102. rm -rf $virtdir
  103. exit 1
  104. else
  105. echo " done."
  106. fi
  107. pip -q uninstall -y mwparserfromhell
  108. echo -n "Downloading mwparserfromhell source tarball and GPG signature..."
  109. curl -sL "https://pypi.io/packages/source/m/mwparserfromhell/mwparserfromhell-$VERSION.tar.gz" -o "mwparserfromhell.tar.gz"
  110. curl -sL "https://pypi.io/packages/source/m/mwparserfromhell/mwparserfromhell-$VERSION.tar.gz.asc" -o "mwparserfromhell.tar.gz.asc"
  111. echo " done."
  112. echo "Verifying tarball..."
  113. gpg --verify mwparserfromhell.tar.gz.asc mwparserfromhell.tar.gz
  114. if [[ "$?" != "0" ]]; then
  115. echo "*** ERROR: GPG signature verification failed!"
  116. deactivate
  117. cd ..
  118. rm -rf $virtdir
  119. exit 1
  120. fi
  121. tar -xf mwparserfromhell.tar.gz
  122. rm mwparserfromhell.tar.gz mwparserfromhell.tar.gz.asc
  123. cd mwparserfromhell-$VERSION
  124. echo "Running unit tests..."
  125. python setup.py -q test
  126. if [[ "$?" != "0" ]]; then
  127. echo "*** ERROR: Unit tests failed!"
  128. deactivate
  129. cd ../..
  130. rm -rf $virtdir
  131. exit 1
  132. fi
  133. echo -n "Everything looks good. Cleaning up..."
  134. deactivate
  135. cd ../..
  136. rm -rf $virtdir
  137. echo " done."
  138. }
  139. echo "Preparing mwparserfromhell v$VERSION..."
  140. cd "$SCRIPT_DIR/.."
  141. check_git
  142. update_version
  143. update_appveyor
  144. update_changelog
  145. update_docs_changelog
  146. do_git_stuff
  147. upload_to_pypi
  148. post_release
  149. test_release
  150. echo "All done."
  151. exit 0